/*
    BetterSearch 1.9
    (T.E.F.K.A.M.)*
    2005-08-26
    (c) 2004, 2005 Carlo Zottmann

    *) "The Extension Formerly Known As McSearchPreview"
       (name was changed in 1.7)

    Thanks to:
        - Andreas Pizsa (of MoreGoogle.com fame -- this is where I got the
                            original idea for the extension from.)


    YOU ARE NOT ALLOWED TO USE THIS EXTENSION IF YOU RIP OUT MY AMAZON
    ASSOCIATE CODE. AMAZON LINKS ARE ***ONLY*** TAGGED WITH MY REFERRAL ID ON
    PAGES THAT HAVE BEEN PROCESSED BY BETTERSEARCH, I.E. PAGES THAT HAVE
    THUMBNAILS ADDED.

    IF YOU CAN'T LIVE WITH THE AFFILIATE CODE IN THESE FEW CHANGED AMAZON
    LINKS, THEN PLEASE UNINSTALL THIS EXTENSION RIGHT NOW. THANK YOU.

    Please remember: just because the extension is tagging Amazon results
    doesn't mean it's costing YOU money. *Amazon* is paying their affiliates,
    and just because a result is tagged with an affiliate ID it's not more
    expensive. :) It's costing the same either way. No harm done.
*/



// Weeeeeee for namespaces, and yes, I'm aware I'm taking this way to literally.
if (typeof CarloZottmann != "object") { var CarloZottmann = {}; }

CarloZottmann.BetterSearch = function()
{
    var config = new CarloZottmann.Helper.BetterSearch.Config("extensions.bettersearch");
    var helperAmazon = CarloZottmann.Helper.BetterSearch.Amazon;
    var helperURL = CarloZottmann.Helper.BetterSearch.URL;
    var helperDocument = null;
    var gXMLHttpRequest = new Array();

    this.load = function(eObject)
    {
        //@JSD_LOG "Starting..."

        var searchKeyword;
        var tempConfig;

        this.toggleStatusBarIcon();
        //@JSD_LOG "Passed this.toggleStatusBarIcon()"

        this._doc = eObject.originalTarget;
        this._location = this._doc.location.href;
        this._serverName = helperURL.getServerName(this._location);
        this._engineName = null;

        helperDocument = new CarloZottmann.Helper.BetterSearch.Document(this._doc);

        if ((searchKeyword = this._location.match(/^keyword:(.+)$/i)))
        {
            tempConfig = new CarloZottmann.Helper.BetterSearch.Config("keyword");
            this._location = tempConfig.getPref("URL") + searchKeyword[1];
            this._serverName = helperURL.getServerName(this._location);
        }
        //@JSD_LOG "Passed searchKeyword check"

        if (!this.isValidSite()) return true;
        //@JSD_LOG "Passed isValidSite()"

        if (config.getPref("thumbnails.type") != 0 ||
            config.getPref("show.siteInfoLink") ||
            config.getPref("show.newWindowLink") ||
            config.getPref("show.waybackLink") ||
            config.getPref("show.asinInfo") ||
            config.getPref("show.iframePreview"))
        {
            //@JSD_LOG "There's work to do!"
            this.processDocument();
            //@JSD_LOG "Work's done!"
        }

        this.amazonifyDocument();
        //@JSD_LOG "Passed this.amazonifyDocument()"

        //@JSD_LOG "...and DONE!"
        return true;
    }



    this.normalizeURL = function(href)
    {
        var normalizedHref = null;

        switch (this._engineName)
        {
            case "YAHOO":
                normalizedHref = href.match(/(?:^http%3A\/\/[^\.]+\.yahoo\.com\/click\?u=|\*\*|\*-)(http.+)$/i);
                break;

            case "GOOGLE":
                normalizedHref = href.match(/^http:\/\/(?:www\.)?google\.[^\/]+\/url\?.*&q=(http:.+)&e=[0-9]+/i);
                break;

            case "ATW":
                normalizedHref = href.match(/\*\*(http%3a.+)$/i);
                break;

            case "A9":
                normalizedHref = href.match(/(?!http:\/\/(?:www\.)?a9\.com)?\/-\/search\/a9-redirect\.jsp\?url=([^&]+)&/i);
                break;

            case "DOGPILE":
                normalizedHref = href.match(/rawto=(http.+)$/i);
                break;
        }

        return (normalizedHref) ? unescape(normalizedHref[1]) : href;
    }



    this.isValidSite = function()
    {
        var siteTest;

        if (this._location.match(/search\.yahoo\.[a-z]+\/search\/[a-z]+/i)
            || this._serverName.match(/^(?!www)\.google\./i)
            || this._location.match(/google\..+\/adsense\//i)
            || this._location.match(/alltheweb\..+\/cat=(?!web)\//i)
            || this._location.match(/dogpile\..+\/search\/(?!web)/i)
            || this._location.match(/search\.msn\.[a-z]+\/(?!results|local)/i))
        {
            return false;
        }

        siteTest = this._serverName.match(/(del\.icio\.us|dogpile\.com|www\.google\.|search\.yahoo\.com|search\.msn|alltheweb\.com|a9\.com|simpy\.com|answers\.com)/i);

        if (siteTest)
        {
            switch (siteTest[1])
            {
                case "a9.com":
                    this._engineName = "A9";
                    return config.getPref("enable.a9");
                    break;

                case "answers.com":
                    this._engineName = "ANSWERS";
                    return config.getPref("enable.answers");
                    break;

                case "alltheweb.com":
                    this._engineName = "ATW";
                    return config.getPref("enable.atw");
                    break;

                case "del.icio.us":
                    this._engineName = "DELICIOUS";
                    return config.getPref("enable.delicious");
                    break;

                case "dogpile.com":
                    this._engineName = "DOGPILE";
                    return config.getPref("enable.dogpile");
                    break;

                case "www.google.":
                    this._engineName = "GOOGLE";
                    return config.getPref("enable.google");
                    break;

                case "search.msn":
                    this._engineName = "MSN";
                    return config.getPref("enable.msn");
                    break;

                case "search.yahoo.com":
                    this._engineName = "YAHOO";
                    return config.getPref("enable.yahoo");
                    break;

                case "simpy.com":
                    this._engineName = "SIMPY";
                    return config.getPref("enable.simpy");
                    break;
            }
        }

        return false;
    }



    this.amazonifyDocument = function()
    {
        var allLinks;
        var currentLink;
        var href;
        var path;

        allLinks = this._doc.getElementsByTagName("a");

        for (a = 0; a < allLinks.length; a++)
        {
            currentLink = allLinks[a];
            href = currentLink.href;

            if (href.match(/amazon\./i) && !href.match(/tag=zottmann/i))
            {
                currentLink.setAttribute("href", this.getAmazonifiedURL(href));
            }
        }
    }



    this.getAmazonifiedURL = function(href)
    {
        var href;
        var path;

        href = this.normalizeURL(href);
        path = escape(helperAmazon.getPath(href));

        switch (helperAmazon.getTLD(href))
        {
            case "com":
                href= "http://www.amazon.com/exec/obidos/redirect?tag=zottmann5-20&path=" + path;
                break;

            case "de":
                href = "http://www.amazon.de/exec/obidos/redirect?tag=zottmann509-21&path=" + path;
                break;

            case "co.uk":
                href = "http://www.amazon.co.uk/exec/obidos/redirect?tag=zottmann5-21&path=" + path;
                break;

            case "fr":
                href = "http://www.amazon.fr/exec/obidos/redirect?tag=zottmann0b-21&path=" + path;
                break;

            case "ca":
                href = "http://www.amazon.ca/exec/obidos/redirect?tag=zottmann085-20&path=" + path;
                break;
        }

        return href;
    }



    this.getThumbnailURL = function(href, thumbnailType)
    {
        var href;
        var hrefServerName;
        var amazonTLD;
        var asin;
        var thumbnailType;

        href = this.normalizeURL(href);
        hrefServerName = helperURL.getServerName(href);
        amazonTLD = helperAmazon.getTLD(href);

        if (amazonTLD)
        {
            asin = helperAmazon.getASIN(href);

            if (asin != null)
            {
                switch (amazonTLD)
                {
                    case "com":
                        return "http://images.amazon.com/images/P/" + asin + ".01.TZZZZZZZ.jpg";
                        break;

                    case "de":
                        return "http://images-eu.amazon.com/images/P/" + asin + ".03.TZZZZZZZ.jpg";
                        break;

                    case "co.uk":
                        return "http://images-eu.amazon.com/images/P/" + asin + ".02.TZZZZZZZ.jpg";
                        break;

                    case "fr":
                        return "http://images-eu.amazon.com/images/P/" + asin + ".01.TZZZZZZZ.jpg";
                        break;

                    case "ca":
                        return "http://images.amazon.com/images/P/" + asin + ".01.TZZZZZZZ.jpg";
                        break;
                }
            }
        }

        switch (thumbnailType)
        {
            case 1:
                return (config.getPref("thumbnails.anonymizeAlexa") ? "http://www.anonymization.net/" : "") + "http://thumbnails.alexa.com/image_server.cgi?size=small&url=" + hrefServerName;
                break;

            case 2:
                return "http://open.thumbshots.org/image.pxf?url=" + hrefServerName;
                break;

            case 3:
                return "http://open.thumbshots.org/image.pxf?url=" + hrefServerName;
                break;
        }

        return null;
    }



    this.buildThumbnail = function(href)
    {
        var href;
        var thumbnailURL;
        var enclosingATag;
        var thumb;
        var maxWidthOff;
        var maxHeightOff;
        var maxWidthOn;
        var maxHeightOn;
        var isASIN;

        thumbnailURL = this.getThumbnailURL(href, config.getPref("thumbnails.type"));
        isASIN = (href.match(/amazon\./i) && helperAmazon.getASIN(href) != null) ? true : false;

        enclosingATag = this._doc.createElement("a");
        enclosingATag.href = href.match(/amazon\./i) ? this.getAmazonifiedURL(href) : href;
        enclosingATag.setAttribute("name", "mcspdone");

        thumb = this._doc.createElement("img");
        thumb.setAttribute("src", thumbnailURL);
        thumb.setAttribute("align", "left");
        thumb.setAttribute("class", "mcspThumb");
        thumb.setAttribute("border", "0");

        if (config.getPref("thumbnails.zoomMode"))
        {
            maxWidthOff = "56px";
            maxHeightOff = "41px";

            maxWidthOn = "112px";
            maxHeightOn = "82px";

            if (isASIN)
            {
                thumb.setAttribute("onMouseOver", "if (this.naturalWidth > 1) { this.style.maxHeight = '" + maxHeightOn + "'; }");
                thumb.setAttribute("onMouseOut", "if (this.naturalWidth > 1) { this.style.maxHeight = '" + maxHeightOff + "'; }");
            }
            else
            {
                thumb.setAttribute("onMouseOver", "this.style.width = '" + maxWidthOn + "'; this.style.height = '" + maxHeightOn + "';");
                thumb.setAttribute("onMouseOut", "this.style.width = '" + maxWidthOff + "'; this.style.height = '" + maxHeightOff + "';");
            }
        }
        else
        {
            maxWidthOff = "112px";
            maxHeightOff = "82px";
        }

        if (isASIN)
        {
            thumb.style.maxHeight = "110px";
            thumb.style.maxWidth = "110px";
        }
        else
        {
            thumb.style.height = maxHeightOff;
            thumb.style.width = maxWidthOff;
        }

        switch (config.getPref("thumbnails.type"))
        {
            case 1:
            case 2:
                thumb.style.margin = "2px 4px 5px 0px";
                break;

            case 3:
                thumb.style.margin = "2px 4px 5px 0px";
                if (!isASIN)
                {
                    thumb.style.border = "1px solid #aaa";
                    thumb.setAttribute("onLoad", "if (this.naturalWidth == 1) { this.src = '" + this.getThumbnailURL(href, 1) + "'; this.style.border = '0px'; }");
                }
                break;
        }

        enclosingATag.appendChild(thumb);

        return enclosingATag;
    }



    this.buildAmazonInfoBlock = function(href)
    {
        var href;
        var amazonTLD;
        var block;
        var asin;
        var url;
        var id;

        amazonTLD = helperAmazon.getTLD(href);
        block = this._doc.createElement("span");

        if (amazonTLD)
        {
            asin = helperAmazon.getASIN(href);

            if (asin)
            {
                url = "http://bettersearch.g-blog.net/ext_asin/?asin=" + asin + "&tld=" + amazonTLD;

                id = "bsAsinInfo-" + amazonTLD + "-" + asin;
                block.setAttribute("id", id);

                // Welcome to the Mother of all dirty hacks. Or is this a good way to do it??
                gXMLHttpRequest[id] = new XMLHttpRequest();
                gXMLHttpRequest[id]._doc = this._doc;
                gXMLHttpRequest[id]._url = url;
                gXMLHttpRequest[id]._id = id;
                gXMLHttpRequest[id].open("GET", url);
                gXMLHttpRequest[id].addEventListener("load", this.updateAmazonInfoBlock, false);
                gXMLHttpRequest[id].send(null);
            }
        }

        return block;
    }



    this.updateAmazonInfoBlock = function()
    {
        // In here "this" means the XMLHttpRequest object, remember! (See "Mother of all dirty hacks" above.)
        //@JSD_BREAK 1 == 1
        if (this._doc.getElementById(this._id))
        {
            if (this.responseText.toLowerCase().indexOf("&middot;") != -1)
            {
                this._doc.getElementById(this._id).innerHTML = "<br/>" + this.responseText;
            }
        }
    }



    this.buildNewWindowLink = function(href)
    {
        var href;
        var newLink;

        newLink = this._doc.createElement("a");
        newLink.href = href;
        newLink.target = "_blank";
        newLink.style.textDecoration = "none";
        newLink.setAttribute("name", "mcspdone");
        newLink.innerHTML = '&nbsp;&nbsp;<img src="chrome://bettersearch/content/nw.gif" border="0" height="11" width="11" class="bsResultIcon" />';
        newLink.title = document.getElementById('bettersearch-strings').getString("OpenInNewTooltip")

        return newLink;
    }



    this.buildSiteInfoLink = function(href)
    {
        var href;
        var siteInfoLink;
        var siteInfoTooltip;

        siteInfoTooltip = document.getElementById('bettersearch-strings').getString("SiteInfoTooltip");

        siteInfoLink = this._doc.createElement('a');
        siteInfoLink.href = "http://www.alexa.com/data/details/?amzn_id=zottmann5-20&url=" + helperURL.getServerName(this.normalizeURL(href));
        siteInfoLink.target = "_blank";
        siteInfoLink.title = siteInfoTooltip;
        siteInfoLink.style.textDecoration = "none";
        siteInfoLink.setAttribute("name", "mcspdone");

        switch (this._engineName)
        {
            case "GOOGLE":
                siteInfoLink.setAttribute("class", "fl");
                siteInfoLink.style.fontSize = "small";
                break;

            case "DELICIOUS":
                siteInfoLink.setAttribute("class", "delNav");
                siteInfoLink.style.fontSize = "70%";
                break;
        }

        siteInfoLink.innerHTML = '&nbsp;&nbsp;<img src="chrome://bettersearch/content/site_info_icon.gif" border="0" height="11" width="9" class="bsResultIcon" />';
        siteInfoLink.title = siteInfoTooltip;

        return siteInfoLink;
    }



    this.buildQuickPreviewLink = function(href, number)
    {
        var href;
        var number;
        var quickPreviewLink;
        var quickPreviewTooltip;

        quickPreviewTooltip = document.getElementById('bettersearch-strings').getString("QuickPreviewTooltip");

        quickPreviewLink = this._doc.createElement('a');
        quickPreviewLink.href = "#BS_QP_" + number;
        quickPreviewLink.title = quickPreviewTooltip;
        quickPreviewLink.style.textDecoration = "none";
        quickPreviewLink.setAttribute("name", "mcspdone");
        quickPreviewLink.setAttribute("onclick", "bsToggleQP(" + number + ", '" + href + "')");

        switch (this._engineName)
        {
            case "GOOGLE":
                quickPreviewLink.setAttribute("class", "fl");
                quickPreviewLink.style.fontSize = "small";
                break;

            case "DELICIOUS":
                quickPreviewLink.setAttribute("class", "delNav");
                quickPreviewLink.style.fontSize = "70%";
                break;
        }

        quickPreviewLink.innerHTML = '&nbsp;&nbsp;<img src="chrome://bettersearch/content/qpreview_icon.gif" border="0" height="11" width="9" class="bsResultIcon" />';
        quickPreviewLink.title = quickPreviewTooltip;

        return quickPreviewLink;
    }



    this.buildWebArchiveLink = function(href)
    {
        var href;
        var webArchiveLink;

        webArchiveLink = this._doc.createElement('a');

        webArchiveLink.href = "http://web.archive.org/web/*/" + helperURL.getServerName(this.normalizeURL(href));
        webArchiveLink.target = "_blank";
        webArchiveLink.title = document.getElementById('bettersearch-strings').getString("WBMTooltip");
        webArchiveLink.className = 'bsArchiveLink';
        webArchiveLink.style.color = "#666";
        webArchiveLink.setAttribute("name", "mcspdone");
        webArchiveLink.innerHTML = document.getElementById('bettersearch-strings').getString("ArchiveTitle");

        return webArchiveLink;
    }




    this.buildEnhancements = function(aHref, number)
    {
        var aHref;
        var number;
        var href;
        var containerSpan;
        var quickPreviewSpan;

        href = this.normalizeURL(aHref);
        containerSpan = this._doc.createElement('span');

        if (config.getPref("show.newWindowLink"))
        {
            containerSpan.appendChild(this.buildNewWindowLink(aHref));
        }

        if (config.getPref("show.siteInfoLink"))
        {
            containerSpan.appendChild(this.buildSiteInfoLink(href));
        }

        if (config.getPref("show.iframePreview"))
        {
            containerSpan.appendChild(this.buildQuickPreviewLink(href, number));
        }

        if (config.getPref("show.waybackLink"))
        {
            containerSpan.appendChild(this.buildWebArchiveLink(href));
        }

        if (config.getPref("show.iframePreview"))
        {
            quickPreviewSpan = this._doc.createElement('span');
            quickPreviewSpan.setAttribute("id", "BS_QP_" + number);
            quickPreviewSpan.style.display = "none";

            containerSpan.appendChild(quickPreviewSpan);
        }

        if (config.getPref("show.asinInfo") && helperAmazon.getTLD(href))
        {
            containerSpan.appendChild(this.buildAmazonInfoBlock(href));
        }

        return containerSpan;
    }



    this.buildBrClearBoth = function()
    {
        var brClearBoth;

        brClearBoth = this._doc.createElement("br");
        brClearBoth.style.clear = "both";
        brClearBoth.style.lineHeight = "5px";

        return brClearBoth;
    }



    this.processDocument = function()
    {
        var thumbnailCount = 0;
        var i;
        var table;
        var a;
        var href;
        var aParent;
        var brClearBoth;

        this.toggleStatusBarIcon();

        helperDocument.injectCSS("A.bsArchiveLink { position: relative; top: -2px; margin: 0px 8px 0px 8px; text-decoration: none; text-transform: uppercase; font-family: Arial, Helvetica, sans-serif; font-size: 10px; color: #666; }");

        if (config.getPref("icons.big"))
        {
            helperDocument.injectCSS(".bsResultIcon { border: 1px solid #66d; border-right: 3px solid #99b; padding: 3px; margin-bottom: -3px; }\nA.bsArchiveLink { font-size: 12px; border: 1px solid #66d; padding: 1px; }");
        }

        if (config.getPref("show.iframePreview"))
        {
            helperDocument.injectJavascript("function bsToggleQP(num, url)\n{\n try\n {\n bsQPID = 'BS_QP_' + num;\n bsQPIFID = 'BS_QP_' + num + '_IF';\n\n bsQP = document.getElementById(bsQPID);\n\n if (!document.getElementById(bsQPIFID))\n {\n quickPreviewBr = document.createElement('br');\n\n quickPreviewIframe = document.createElement('iframe');\n quickPreviewIframe.setAttribute('id', 'BS_QP_' + num + '_IF');\n quickPreviewIframe.src = url;\n quickPreviewIframe.width = '820';\n quickPreviewIframe.height = '400';\n quickPreviewIframe.style.position = 'relative';\n quickPreviewIframe.style.zIndex = 100;\n quickPreviewIframe.style.backgroundColor = 'white';\n quickPreviewIframe.style.margin = '5px';\n quickPreviewIframe.style.border = '2px solid orange';\n quickPreviewIframe.style.clear = 'both';\n\n bsQP.appendChild(quickPreviewBr);\n bsQP.appendChild(quickPreviewIframe);\n\n bsQP.style.display = 'inline';\n }\n else\n {\n bsQP.removeChild(bsQP.firstChild);\n bsQP.removeChild(bsQP.firstChild);\n bsQP.style.display = 'none';\n }\n }\n catch (e)\n {\n alert('BetterSearch Error: QuickPreview ' + bsQPID + ' object doesn\\\'t exist!');\n }\n}\n");
        }

        switch (this._engineName)
        {
            case "GOOGLE":
                helperDocument.injectCSS("P.g { clear: left; }");

                for (i = 0; i < this._doc.getElementsByTagName("table").length; i++)
                {
                    table = this._doc.getElementsByTagName("table")[i];

                    if (table.getAttribute("align") == "right")
                    {
                        table.style.zIndex = "100";
                        table.style.position = "absolute";
                        table.style.right = "0px";
                    }
                }

                for (i = 0; i < this._doc.getElementsByTagName("a").length; i++)
                {
                    a = this._doc.getElementsByTagName("a")[i];
                    href = this.normalizeURL(a.href);

                    aParent = a.parentNode;

                    // Insert thumbnails and enhancements (where applicable)
                    if (href.match(/^https?:/) && aParent.getAttribute("class") == "g" && a.getAttribute("name") != "mcspdone")
                    {
                        aParent.insertBefore(this.buildEnhancements(a.href, thumbnailCount), a.nextSibling);

                        if (config.getPref("thumbnails.type") != 0 &&
                            (config.getPref("thumbnails.maxnum") == 0 || thumbnailCount < config.getPref("thumbnails.maxnum"))
                            )
                        {
                            thumbnailCount++;
                            aParent.insertBefore(this.buildThumbnail(href), aParent.firstChild);
                        }

                        aParent.parentNode.insertBefore(this.buildBrClearBoth(), aParent.nextSibling);

                        a.setAttribute("name", "mcspdone");
                    }
                }

                break;



            case "A9":
                helperDocument.injectCSS("DIV#webContent > DIV > DIV { clear: left; }");

                // Hide the original Site Info button so it doesn't mess up the layout
                helperDocument.injectCSS(".site-info { display: none; }");

                for (i = 0; i < this._doc.getElementsByTagName("a").length; i++)
                {
                    a = this._doc.getElementsByTagName("a")[i];
                    href = this.normalizeURL(a.href);

                    aParent = a.parentNode;

                    // Insert thumbnails and enhancements (where applicable)
                    if (href.match(/^https?:/)
                        && a.getAttribute("class") == "r-a"
                        && (a.parentNode.parentNode.id == "booksContent" || a.parentNode.parentNode.parentNode.id == "webContent")
                        && a.getAttribute("name") != "mcspdone"
                        )
                    {
                        if (config.getPref("thumbnails.type") != 0
                            && (config.getPref("thumbnails.maxnum") == 0 || thumbnailCount < config.getPref("thumbnails.maxnum"))
                            && a.parentNode.parentNode.parentNode.id == "webContent"
                            )
                        {
                            thumbnailCount++;
                            a.parentNode.insertBefore(this.buildThumbnail(this.normalizeURL(href)), a.parentNode.firstChild);
                        }

                        a.parentNode.insertBefore(this.buildEnhancements(a.href, thumbnailCount), a.nextSibling);

                        if (a.parentNode.parentNode.id == "booksContent")
                        {
                            a.parentNode.insertBefore(this.buildBrClearBoth(), a);
                            a.parentNode.insertBefore(this.buildBrClearBoth(), a);
                        }

                        a.setAttribute("name", "mcspdone");
                    }
                }
                break;



            case "ANSWERS":
                helperDocument.injectCSS("#results A.urlLink { padding-bottom: 15px; display: block; }\n#results P { clear: left; margin-bottom: 30px; }");

                for (i = 0; i < this._doc.getElementsByTagName("a").length; i++)
                {
                    a = this._doc.getElementsByTagName("a")[i];
                    href = this.normalizeURL(a.href);

                    aParent = a.parentNode;

                    // Insert thumbnails and enhancements (where applicable)
                    if (href.match(/^https?:/) && a.getAttribute("class") == "headerLink" && a.getAttribute("name") != "mcspdone")
                    {
                        aParent.insertBefore(this.buildEnhancements(a.href, thumbnailCount), a.nextSibling);
                        // aParent.insertBefore(this.buildBrClearBoth(), a);

                        if (config.getPref("thumbnails.type") != 0 &&
                            (config.getPref("thumbnails.maxnum") == 0 || thumbnailCount < config.getPref("thumbnails.maxnum"))
                            )
                        {
                            thumbnailCount++;
                            aParent.insertBefore(this.buildThumbnail(href), a);
                        }

                        a.setAttribute("name", "mcspdone");
                    }
                }

                break;



            case "ATW":
                helperDocument.injectCSS("P.result { clear: left; }");

                for (i = 0; i < this._doc.getElementsByTagName("a").length; i++)
                {
                    a = this._doc.getElementsByTagName("a")[i];
                    href = this.normalizeURL(a.href);

                    aParent = a.parentNode;

                    // Insert thumbnails and enhancements (where applicable)
                    if (href.match(/^https?:/) && a.getAttribute("class") == "res" && a.getAttribute("name") != "mcspdone")
                    {
                        if (config.getPref("thumbnails.type") != 0 &&
                            (config.getPref("thumbnails.maxnum") == 0 || thumbnailCount < config.getPref("thumbnails.maxnum"))
                            )
                        {
                            thumbnailCount++;
                            aParent.insertBefore(this.buildThumbnail(href), aParent.firstChild);
                        }

                        aParent.insertBefore(this.buildEnhancements(a.href, thumbnailCount), a.nextSibling);

                        a.setAttribute("name", "mcspdone");
                    }
                }

                break;



            case "DELICIOUS":
                helperDocument.injectCSS(".post { clear: left; }");

                for (i = 0; i < this._doc.getElementsByTagName("a").length; i++)
                {
                    a = this._doc.getElementsByTagName("a")[i];
                    href = this.normalizeURL(a.href);

                    // Insert thumbnails and enhancements (where applicable)
                    if (href.indexOf("http") == 0 && a.parentNode.className == "desc" && a.parentNode.parentNode.className == "post" && a.getAttribute("name") != "mcspdone")
                    {
                        a.parentNode.appendChild(this.buildEnhancements(a.href, thumbnailCount));

                        if (config.getPref("thumbnails.type") != 0 &&
                            (config.getPref("thumbnails.maxnum") == 0 || thumbnailCount < config.getPref("thumbnails.maxnum"))
                            )
                        {
                            thumbnailCount++;
                            a.parentNode.parentNode.insertBefore(this.buildThumbnail(this.normalizeURL(href)), a.parentNode.parentNode.firstChild);
                        }

                        a.setAttribute("name", "mcspdone");
                    }
                }

                helperDocument.injectCSS("IMG[title^='posted by'] { margin-top: 2px; border: 1px solid #CCF; }");

                break;



            case "DOGPILE":
                helperDocument.injectCSS("DIV.listings { clear: left; }");

                for (i = 0; i < this._doc.getElementsByTagName("a").length; i++)
                {
                    a = this._doc.getElementsByTagName("a")[i];
                    href = this.normalizeURL(a.href);

                    // Insert thumbnails and enhancements (where applicable)
                    if (a.className == "resultsLink" && a.getAttribute("name") != "mcspdone")
                    {
                        a.parentNode.insertBefore(this.buildEnhancements(a.href, thumbnailCount), a.nextSibling);

                        if (config.getPref("thumbnails.type") != 0 &&
                            (config.getPref("thumbnails.maxnum") == 0 || thumbnailCount < config.getPref("thumbnails.maxnum"))
                            )
                        {
                            thumbnailCount++;
                            a.parentNode.insertBefore(this.buildThumbnail(this.normalizeURL(href)), a);
                        }

                        a.setAttribute("name", "mcspdone");
                    }
                }

                break;



            case "MSN":
                for (i = 0; i < this._doc.getElementsByTagName("a").length; i++)
                {
                    a = this._doc.getElementsByTagName("a")[i];
                    href = this.normalizeURL(a.href);

                    aParent = a.parentNode;

                    // Insert thumbnails and enhancements (where applicable)
                    if (aParent.nodeName == "H3" && a.getAttribute("name") != "mcspdone" && !a.getAttribute("onmouseover") && aParent.parentNode.parentNode.parentNode.id == "results")
                    {
                        aParent.insertBefore(this.buildEnhancements(a.href, thumbnailCount), a.nextSibling);

                        if (config.getPref("thumbnails.type") != 0
                            && (config.getPref("thumbnails.maxnum") == 0 || thumbnailCount < config.getPref("thumbnails.maxnum")
                            && !this._location.match(/\/news\/results/i))
                            )
                        {
                            thumbnailCount++;
                            aParent.parentNode.insertBefore(this.buildThumbnail(href), aParent.parentNode.firstChild);
                        }

                        aParent.parentNode.appendChild(this.buildBrClearBoth());

                        a.setAttribute("name", "mcspdone");
                    }
                }
                break;



            case "SIMPY":
                helperDocument.injectCSS("DIV.mcsp { clear: both; }");

                for (i = 0; i < this._doc.getElementsByTagName("a").length; i++)
                {
                    a = this._doc.getElementsByTagName("a")[i];
                    href = this.normalizeURL(a.href);

                    // Insert thumbnails and enhancements (where applicable)
                    if (href.match(/^https?:/) && a.getAttribute("class") == "mcsp" && a.getAttribute("name") != "mcspdone")
                    {
                        aParent = a.parentNode;

                        if (config.getPref("thumbnails.type") != 0 &&
                            (config.getPref("thumbnails.maxnum") == 0 || thumbnailCount < config.getPref("thumbnails.maxnum"))
                            )
                        {
                            thumbnailCount++;
                            thumbnail = this.buildThumbnail(this.normalizeURL(href));
                            thumbnail.setAttribute("style", thumbnail.getAttribute("style") + "float: right;");
                            aParent.insertBefore(thumbnail, aParent.firstChild);
                        }

                        a.parentNode.insertBefore(this.buildEnhancements(a.href, thumbnailCount), a.nextSibling);

                        a.setAttribute("name", "mcspdone");
                        aParent.setAttribute("class", "mcsp");
                    }
                }

                break;



            case "YAHOO":
                helperDocument.injectCSS('IMG[src$="\/bn\/nw2.gif"] { display: none; }\n#yschmyresults > UL > LI, OL > LI { clear: left; padding-bottom: 20px; }\n#yschcommresults > H3, #yschmyresults > H3 { clear: both; padding-top: 20px; }\n#savedpages > UL > LI { display: block; padding-bottom: 25px; }');

                for (i = 0; i < this._doc.getElementsByTagName("a").length; i++)
                {
                    a = this._doc.getElementsByTagName("a")[i];
                    href = this.normalizeURL(a.href);

                    // Insert thumbnails and enhancements (where applicable)
                    if (href.match(/^https?:/)
                        && (a.getAttribute("class") == "yschttl"
                            || a.getAttribute("class") == "rt"
                            || (a.parentNode.parentNode.parentNode.parentNode.id == "savedpages" && a.parentNode.tagName == "CITE") // My Web 2.0 saved pages
                            )
                        && a.getAttribute("name") != "mcspdone")
                    {
                        a.parentNode.appendChild(this.buildEnhancements(a.href, thumbnailCount));

                        if (config.getPref("thumbnails.type") != 0 &&
                            (config.getPref("thumbnails.maxnum") == 0 || thumbnailCount < config.getPref("thumbnails.maxnum"))
                            )
                        {
                            thumbnailCount++;
                            if (a.parentNode.tagName != "LI")
                            {
                                a.parentNode.parentNode.insertBefore(this.buildThumbnail(href), a.parentNode.parentNode.firstChild);
                            }
                            else
                            {
                                a.parentNode.insertBefore(this.buildThumbnail(href), a.parentNode.firstChild);
                            }
                        }

                        a.setAttribute("name", "mcspdone");
                    }
                }

                break;
        }

    }



    this.toggleStatusBarIcon = function()
    {
        if (document.getElementById("bettersearch-status"))
        {
            document.getElementById("bettersearch-status").style.visibility = !config.getPref("disableStatusBarIcon") ? "visible" : "collapse";
        }
    }



    this.openOptionsDialog = function()
    {
        window.openDialog('chrome://bettersearch/content/optionsDialog.xul', "BS_Options", 'chrome, modal, dialog, centerscreen');
        this.toggleStatusBarIcon();

        if (this._engineName)
        {
            this._doc.location.reload();
        }
    }
}






var betterSearch = new CarloZottmann.BetterSearch();

window.addEventListener("load",
                        function()
                        {
                            function load(eObject) { betterSearch.load(eObject); }
                            window.document.getElementById("appcontent").addEventListener("DOMContentLoaded", load, false);
                        },
                        false);


